import type { DBOps } from './types';
import level from 'level';
import { Block, Call, Contract, ExecutionSummary, LocalMetadata, Outcome, Shard, ShardMetadata } from './borsh';
export declare class Storage {
    static getCallIndex(shardId: number, callIndex: number): string;
    static getCallOutcomeIndex(shardId: number, callIndex: number): string;
    static getBlockIndex(shardId: number, blockNumber: number): string;
    static getContractIndex(contractIndex: number): string;
    static getShardIndex(shardId: number): string;
    static getShardMetadataIndex(shardId: number): string;
    static writeMetadata(metadata: LocalMetadata): DBOps;
    static getMetadata(db: level.LevelDB): Promise<LocalMetadata>;
    static writeCallRecord(shard_id: number, callIndex: number, call: Call): DBOps;
    static writeCallOutcome(shardId: number, callIndex: number, outcome: Outcome): DBOps;
    static writeBlockRecord(shardId: number, blockNumber: number, block: Block): DBOps;
    static writeContractRecord(contractIndex: number, contract: Contract): DBOps;
    static writeShardRecord(shardId: number, shard: Shard): DBOps;
    static writeShardMetadataRecord(shardId: number, shardm: ShardMetadata): DBOps;
    static writeExecutionSummary(a: ExecutionSummary): DBOps;
    static writeAll(db: level.LevelDB, ops: DBOps[]): Promise<void>;
    static getCallRecord(db: level.LevelDB, shardId: number, callIndex: number): Promise<Call>;
    static getOutcomeRecord(db: level.LevelDB, shardId: number, callIndex: number): Promise<Outcome>;
    static getBlockRecord(db: level.LevelDB, shardId: number, blockNumber: number): Promise<Block>;
    static getContractRecord(db: level.LevelDB, contractIndex: number): Promise<Contract>;
    static getShardRecord(db: level.LevelDB, shardId: number): Promise<Shard>;
    static getShardMetadataRecord(db: level.LevelDB, shardId: number): Promise<ShardMetadata>;
    static getExecutionSummary(db: level.LevelDB): Promise<ExecutionSummary>;
}
